#
# Conditional build:
# _without_emacs	- without emacs subpackage
# _without_tk		- without tk support
# _without_x11		- without X11 support (implies --without tk)
# _with_db3		- use db3 instead of db 4.x
#
%{?_without_x11:%define	_without_tk	1}

Summary:	The Objective Caml compiler and programming environment
Summary(pl):	Kompilator OCamla (Objective Caml) oraz rodowisko programistyczne
Name:		ocaml
Version:	3.06
Release:	2
License:	distributable
Vendor:		Group of implementors <caml-light@inria.fr>
Group:		Development/Languages
Source0:	ftp://ftp.inria.fr/lang/caml-light/%{name}-%{version}/%{name}-%{version}.tar.gz
Source1:	ftp://ftp.inria.fr/lang/caml-light/%{name}-%{version}/%{name}-%{version}-refman.html.tar.gz
Source2:	ftp://ftp.inria.fr/lang/caml-light/%{name}-%{version}/%{name}-%{version}-refman.ps.gz
Source3:	ftp://ftp.inria.fr/INRIA/Projects/cristal/camlp4/camlp4-%{version}-manual.html.tar.gz
Source4:	ftp://ftp.inria.fr/INRIA/Projects/cristal/camlp4/camlp4-%{version}-manual.dvi.gz
Source5:	ftp://ftp.inria.fr/INRIA/Projects/cristal/camlp4/camlp4-%{version}-tutorial.html.tar.gz
Source6:	ftp://ftp.inria.fr/INRIA/Projects/cristal/camlp4/camlp4-%{version}-tutorial.dvi.gz
Source7:	http://www.oefai.at/~markus/ocaml_sources/pure-fun-1.0.4.tar.bz2
Source8:	http://www.oefai.at/~markus/ocaml_sources/ds-contrib.tar.gz
Patch0:		%{name}-build.patch
Patch1:		%{name}-manlinks.patch
Patch2:		%{name}-db3.patch
Patch3:		%{name}-objinfo.patch
Patch4:		%{name}-opt-symbols.patch
Patch5:		%{name}-mano.patch
URL:		http://caml.inria.fr/
Requires:	ocaml-runtime = %{version}-%{release}
Obsoletes:	ocaml-ocamldoc
Provides:	ocaml-ocamldoc
%{?_with_db3:BuildRequires:	db3-devel}
%{!?_with_db3:BuildRequires:	db-devel >= 4.1}
%{!?_without_tk:BuildRequires:		tk-devel}
%{!?_without_x11:BuildRequires:		XFree86-devel}
%{!?_without_emacs:BuildRequires:	xemacs}
%{!?_without_emacs:BuildRequires:	xemacs-common}
%{!?_without_emacs:BuildRequires:	xemacs-fsf-compat-pkg}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)


%description
Objective Caml is a high-level, strongly-typed, functional and
object-oriented programming language from the ML family of languages.

This package comprises two batch compilers (a fast bytecode compiler
and an optimizing native-code compiler), an interactive toplevel
system, Lex&Yacc tools, a replay debugger, and a comprehensive
library.

%description -l pl
OCaml (Objective Caml) jest funkcyjnym, obiektowo zorientowanym jzykiem
wysokiego poziomu z silnym typowaniem. Naley do rodziny jzykw ML.

Ten pakiet zawiera dwa kompilatory (szybki kompilator do bajtkodu
oraz optymalizujcy kompilator do kodu natywnego), interaktywne rodowisko
pracy, narzdzia do tworzenia analizatorw leksykalnych oraz skadniowych
(ocamllex, ocamlyacc), odpluskwiacz (ocamldebug) i biblioteki.

%package doc-ps
Summary:	PostScript documentation for OCaml
Summary(pl):	Dokumentacja dla OCamla w formacie PostScript
Group:		Development/Tools

%description doc-ps
PostScript documentation for OCaml. HTML documentation is in main package.

%description doc-ps -l pl
Dokumentacja dla OCamla w formacie PostScript. Dokumentacja HTML jest
w gwnym pakiecie.

%package emacs
Summary:	Emacs mode for OCaml
Summary(pl):	Tryb OCamla dla Emacsa
Group:		Development/Tools
Requires:	%{name} = %{version}

%description emacs
Emacs mode files for Objective Caml language.

%description emacs -l pl
Pliki trybu OCamla dla Emacsa.

%package runtime
Summary:	Runtime system for OCaml
Summary(pl):	rodowisko uruchomieniowe dla OCamla
Group:		Libraries

%description runtime
This package contains binaries needed to run bytecode OCaml programs:
ocamlrun bytecode interpreter, and basic dynamic link libraries.

%description runtime -l pl
Pakiet ten zawiera binaria potrzebne do uruchamiania programw w
OCamlu skompilowanych do bajtkodu: interpreter bajtkodu (ocamlrun) oraz
podstawowe bibliotki linkowane dynamicznie.

%package labltk-devel
Summary:	LablTk library for OCaml
Summary(pl):	Biblioteka LablTk dla OCamla
Group:		Development/Libraries
Requires:	%{name}-labltk = %{version}-%{release}

%description labltk-devel
LablTk gives OCaml program access to Tcl/Tk GUI widgets. This package
contains files needed to develop OCaml programs using LablTk.

%description labltk-devel -l pl
Biblioteka LablTk daje programom napisanym w OCamlu dostp do widgetw
Tcl/Tk. Pakiet ten zawiera pliki niezbdne do tworzenia programw
uywajcych LablTk.

%package labltk
Summary:	Runtime for LablTk library
Summary(pl):	rodowisko uruchomieniowe dla biblioteki LablTk
Group:		Libraries
Requires:	%{name} = %{version}-%{release}

%description labltk
LablTk gives OCaml program access to Tcl/Tk GUI widgets. This package
contains files needed to run bytecode OCaml programs using LablTk.

%description labltk -l pl
Biblioteka LablTk daje programom napisanym w OCamlu dostp do widgetw
Tcl/Tk. Pakiet ten zawiera binaria potrzebne do uruchamiania programw
uywajcych LablTk.

%package x11graphics-devel
Summary:	X11 graphic output for OCaml
Summary(pl):	Dostp do X11 dla OCamla
Group:		Development/Libraries
Requires:	%{name}-x11graphics = %{version}-%{release}

%description x11graphics-devel
x11graphics module gives OCaml program access to drawing in X11
windows. This package contains files needed to develop OCaml programs
using x11graphics.

%description x11graphics-devel -l pl
Modu x11graphics daje programom napisanym w OCamlu moliwo
korzystania z interfejsu graficznego X11. Pakiet ten zawiera pliki
niezbdne do tworzenia programw uywajcych x11graphics.

%package x11graphics
Summary:	X11 graphic output for OCaml
Summary(pl):	Dostp do X11 dla OCamla
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description x11graphics
x11graphics module gives OCaml program access to drawing in X11
windows. This package contains files needed to run bytecode OCaml
programs using x11graphics.

%description x11graphics -l pl
Modu x11graphics daje programom napisanym w OCamlu moliwo
korzystania z interfejsu graficznego X11. Pakiet ten zawiera binaria
potrzebne do uruchamiania programw uywajcych x11graphics.

%package camlp4
Summary:	Objective Caml Preprocessor
Summary(pl):	Preprocesor OCamla
Group:		Development/Languages
Requires:	%{name} = %{version}-%{release}
Provides:	camlp4 = %{version}-%{release}
Obsoletes:	camlp4

%description camlp4
Camlp4 is a Pre-Processor-Pretty-Printer for Objective Caml. It offers
tools for syntax (grammars) and the ability to modify the concrete
syntax of the language (quotations, syntax extensions).

Camlp4 can parse normal Ocaml concrete syntax or any other
user-definable syntax. As an example, an alternative syntax is
provided, named revised, because it tries to fix some small problems
of the normal syntax.

Camlp4 can pretty print the normal Ocaml concrete syntax or the
revised one. It is therefore always possible to have a version of your
sources compilable by the Objective Caml compiler without
preprocessing.

%description camlp4 -l pl
Camlp4 jest preprocesorem OCamla. Oferuje narzdzia do manipulowania
skadni (gramatyki) oraz moliwo modyfikowania oryginalnej skadni
jzyka (cytowania, rozszerzenia).

Camlp4 moe sparsowa oryginaln skadni Ocamla lub dowoln inn
definiowaln przez uytkownika. Jako przykad podana jest alternatywna
skadnia (revised syntax), ktra prbuje poprawi drobne problemy
wystpujce w skadni oryginalnej.

Camlp4 umie adnie formatowa rda zarwno w oryginalnej jak i
poprawionej skadni OCamla. Potrafi take tumaczy programy z jednej
skadni na drug.

%package devel
Summary:	Compiled parts of OCaml compiler
Summary(pl):	Skompilowane czci kompilatora OCamla
Group:		Development/Languages
Requires:	%{name} = %{version}-%{release}

%description devel
This package contains *.cmi and *.cmo files being parts of OCaml
compiler. They are needed to compile some programs.

%description devel -l pl
Pakiet ten zawiera pliki *.cmi oraz *.cmo bdce czeciami kompilatora
OCamla. S one wymagane do kompilacji niektrych programw.

%package ocamldoc-devel
Summary:	Files needed to develop programs using ocamldoc
Summary(pl):	Pliki potrzebne do tworzenia programw uywajcych ocamldoc
Group:		Development/Languages
Requires:	%{name} = %{version}-%{release}

%description ocamldoc-devel
You need this package if you are going to write ocamldoc front end or
something like that.

%description ocamldoc-devel -l pl
Bdziesz potrzebowa tego pakietu, jeli zamierzasz pisa front end
dla ocamldoc lub co podobnego.

%package lib-source
Summary:	Sources of OCaml standard library
Summary(pl):	rda biblioteki standardowej OCamla
Group:		Development/Languages
Requires:	%{name} = %{version}-%{release}

%description lib-source
This sources come helpful during debugging of user programs with ocamldebug.

%description lib-source -l pl
rda te s przydatne przy odpluskwianiu programw uytkownika
z uyciem ocamldebug.

# maybe we'll want to add some more stuff here?
%package examples
Summary:	Example source code for OCaml
Summary(pl):	Przykadowe kody rdowe w OCamlu
Group:		Development/Languages
Requires:	%{name} = %{version}-%{release}

%description examples
This packages contains sources for Okasaki's Purely Functional 
Datastructures in OCaml, along with some contributions.

%description examples -l pl
Pakiet ten zawiera rda Czysto Funkcyjnych Struktur Danych
autorstwa Okasaki'ego, napisane w OCamlu, wraz z dodatkami.

%prep
%setup -q -T -b 0
%setup -q -T -D -a 1
%setup -q -T -D -c -n %{name}-%{version}/examples -a 7
%setup -q -T -D -c -n %{name}-%{version}/examples -a 8
%setup -q -T -D -n %{name}-%{version} -a 3
%setup -q -T -D -n %{name}-%{version} -a 5
# order mess with docs somewhat
mkdir docs
mkdir docs/html
mv htmlman docs/html/ocaml
cp %{SOURCE2} docs/ocaml.ps.gz
mv camlp4-%{version}-manual.html docs/html/camlp4
cp %{SOURCE4} docs/camlp4.ps.gz
mv camlp4-%{version}-tutorial.html docs/html/camlp4-tutorial
cp %{SOURCE6} docs/camlp4-tutorial.ps.gz
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
#%patch4 -p1
%patch5 -p1

%build
./configure \
        -cc "%{__cc} %{rpmcflags}" \
	-bindir %{_bindir} \
	-libdir %{_libdir}/%{name} \
	-mandir %{_mandir}/man1 \
	-host %{_host} \
	%{?_without_tk:-no-tk} \
	-with-pthread

%{__make} world bootstrap opt.opt
%{__make} -C tools objinfo

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	BINDIR=$RPM_BUILD_ROOT%{_bindir} \
	LIBDIR=$RPM_BUILD_ROOT%{_libdir}/%{name} \
	MANDIR=$RPM_BUILD_ROOT%{_mandir}

cat > $RPM_BUILD_ROOT%{_libdir}/%{name}/ld.conf <<EOF
%{_libdir}/%{name}/stublibs
%{_libdir}/%{name}
EOF

%if %{!?_without_emacs:1}%{?_without_emacs:0}
%{__make} -C emacs DESTDIR=$RPM_BUILD_ROOT install \
	EMACS="`if [ -x %{_bindir}/emacs ]; then echo emacs; \
	        else echo xemacs; fi`" \
	EMACSDIR="$RPM_BUILD_ROOT%{_datadir}/emacs/site-lisp"
%endif

# symlink .opt versions of compilers (if present)
# warning: don't do that with camlp4 (can't load extensions then)
for f in ocamlc ocamlopt ocamldoc ocamllex; do
	if test -f $RPM_BUILD_ROOT%{_bindir}/$f.opt; then
		mv -f $RPM_BUILD_ROOT%{_bindir}/$f \
			$RPM_BUILD_ROOT%{_bindir}/$f.byte
		ln -sf %{_bindir}/$f.opt $RPM_BUILD_ROOT%{_bindir}/$f
	fi
done

# move includes to the proper place
install -d $RPM_BUILD_ROOT%{_includedir}
mv -f $RPM_BUILD_ROOT%{_libdir}/%{name}/caml $RPM_BUILD_ROOT%{_includedir}/caml
# but leave compatibility symlink
ln -s ../../include/caml $RPM_BUILD_ROOT%{_libdir}/%{name}/caml

# compiled sources of compiler, needed by some programs
for f in {asm,byte}comp parsing typing utils ; do
	install -d $RPM_BUILD_ROOT%{_libdir}/%{name}/compiler/$f
	cp $f/*.{cmi,cmo,cmx,o} $RPM_BUILD_ROOT%{_libdir}/%{name}/compiler/$f
done

# this isn't installed by default, but is useful
install tools/objinfo $RPM_BUILD_ROOT%{_bindir}/ocamlobjinfo

install -d $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}
cp -r examples/* $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}

install -d $RPM_BUILD_ROOT%{_examplesdir}/%{name}-labltk-%{version}
cp -r otherlibs/labltk/examples* $RPM_BUILD_ROOT%{_examplesdir}/%{name}-labltk-%{version}

ln -sf %{_libdir}/%{name}/{scrape,add}labels $RPM_BUILD_ROOT%{_bindir}

# shutup checkfiles
rm -rf $RPM_BUILD_ROOT%{_mandir}/man3
rm -f $RPM_BUILD_ROOT%{_libdir}/%{name}/labltk/{labltktop,pp}

%clean
rm -rf $RPM_BUILD_ROOT

%files runtime
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/ocamlrun
%dir %{_libdir}/%{name}
%dir %{_libdir}/%{name}/stublibs
%attr(755,root,root) %{_libdir}/%{name}/stublibs/dll*.so
%exclude %{_libdir}/%{name}/stublibs/dllgraphics.so
%{!?_without_tk:%exclude %{_libdir}/%{name}/stublibs/dlllabltk.so}
%{!?_without_tk:%exclude %{_libdir}/%{name}/stublibs/dlltkanim.so}

%files
%defattr(644,root,root,755)
%doc LICENSE Changes README Upgrading
%doc docs/html/ocaml
%attr(755,root,root) %{_bindir}/ocaml*
%{!?_without_tk:%exclude %{_bindir}/ocamlbrowser}
%exclude %{_bindir}/ocamlrun
%attr(755,root,root) %{_bindir}/*labels
%{_includedir}/caml
%{_libdir}/%{name}/caml
%{_libdir}/%{name}/threads
%{_libdir}/%{name}/*.a
%{_libdir}/%{name}/*.o
%{_libdir}/%{name}/*.cm*
%exclude %{_libdir}/%{name}/*graphics*
%{_libdir}/%{name}/ld.conf
%{_libdir}/%{name}/camlheader
%{_libdir}/%{name}/camlheader_ur
%dir %{_libdir}/%{name}/ocamldoc
%{_libdir}/%{name}/ocamldoc/*.sty
%{_libdir}/%{name}/ocamldoc/*.hva
%attr(755,root,root) %{_libdir}/%{name}/expunge
%attr(755,root,root) %{_libdir}/%{name}/extract_crc
%attr(755,root,root) %{_libdir}/%{name}/*labels
%{_mandir}/man1/*ocaml*

%files lib-source
%defattr(644,root,root,755)
%{_libdir}/%{name}/*.ml
%{_libdir}/%{name}/*.mli

%files examples
%defattr(644,root,root,755)
%{_examplesdir}/%{name}-%{version}

# they are poor, html is much better
#%files manpages
#%{_mandir}/man3/*

%files devel
%defattr(644,root,root,755)
%{_libdir}/%{name}/compiler

%files camlp4
%defattr(644,root,root,755)
%doc docs/html/camlp4*
%attr(755,root,root) %{_bindir}/*camlp4*
%attr(755,root,root) %{_bindir}/ocpp
# Not installed since 3.05, is is needed?
#%attr(755,root,root) %{_bindir}/odyl
%{_libdir}/%{name}/camlp4
%{_mandir}/man*/*camlp4*
%{_mandir}/man*/*ocpp*

%if %{!?_without_tk:1}%{?_without_tk:0}
%files labltk-devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/labltk
%attr(755,root,root) %{_bindir}/ocamlbrowser
%dir %{_libdir}/%{name}/labltk
%{_libdir}/%{name}/labltk/*.cm*
%{_libdir}/%{name}/labltk/*.a
%attr(755,root,root) %{_libdir}/%{name}/labltk/tkcompiler
%{_examplesdir}/%{name}-labltk-%{version}

%files labltk
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/%{name}/stublibs/dlllabltk.so
%attr(755,root,root) %{_libdir}/%{name}/stublibs/dlltkanim.so
%endif

%if %{!?_without_x11:1}%{?_without_x11:0}
%files x11graphics-devel
%defattr(644,root,root,755)
%{_libdir}/%{name}/graphics*.cm*
%{_libdir}/%{name}/graphics.a
%{_libdir}/%{name}/libgraphics.a

%files x11graphics
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/%{name}/stublibs/dllgraphics.so
%endif

%if %{!?_without_emacs:1}%{?_without_emacs:0}
%files emacs
%defattr(644,root,root,755)
%{_datadir}/emacs/site-lisp/*.el*
%endif

%files ocamldoc-devel
%defattr(644,root,root,755)
%{_libdir}/%{name}/ocamldoc/*.cm*
%{_libdir}/%{name}/ocamldoc/*.a

%files doc-ps
%defattr(644,root,root,755)
%doc docs/*.ps.gz
